.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

VERTEX STRUCT
x REAL4 ?
y REAL4 ?
z REAL4 ?
nx REAL4 ?
ny REAL4 ?
nz REAL4 ?
s0 REAL4 ?
t0 REAL4 ?
s1 REAL4 ?
t1 REAL4 ?
s2 REAL4 ?
t2 REAL4 ?
padding REAL4 ?, ?, ?, ?
VERTEX ENDS

.data?
Dest	db 100 dup(?)
DestA	db 100 dup(?)
DestB	db 100 dup(?)

.data
R8s1	REAL8	123.456
R8s2	REAL8	789.012
R8d	REAL8	?

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push offset DestA
			push offset DestB
			push offset Dest
			call Vec_SubSSE
		counter_end
		print str$(eax), 9, "cycles for Vec_SubSSE", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push offset DestA
			push offset DestB
			push offset Dest
			call Vec_Sub
		counter_end
		print str$(eax), 9, "cycles for Vec_Sub", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			REPEAT 100
				fld R8s1
				fmul R8s2
				fstp R8d
			ENDM
		counter_end
		print str$(eax), 9, "cycles for 100*fmul", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			REPEAT 100
				movlps xmm0, R8s1
				mulsd xmm0, R8s2
				movlps R8d, xmm0
			ENDM
		counter_end
		print str$(eax), 9, "cycles for 100*mulsd", 13, 10
		print chr$(13, 10)
	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

Vec_SubSSE	proc	uses ebx DestVec:dword, A:dword, B:dword 
			mov	eax, DestVec
			mov	ebx, A
			mov	ecx, B
		;	fld	dword ptr [ebx + VERTEX.x]
		;	fsub	dword ptr [ecx + VERTEX.x]
		;	fstp	dword ptr [eax + VERTEX.x]
;
;			fld	dword ptr [ebx + VERTEX.y]
;			fsub	dword ptr [ecx + VERTEX.y]
;			fstp	dword ptr [eax + VERTEX.y]
;
;			fld	dword ptr [ebx + VERTEX.z]
;			fsub	dword ptr [ecx + VERTEX.z]
;			fstp	dword ptr [eax + VERTEX.z]
			
			movups xmm0,[ebx]
			movups xmm1,[ecx]
			subps xmm0,xmm1
			movups [eax],xmm0
			
			ret
Vec_SubSSE			endp

Vec_Sub			proc	uses ebx DestVec:dword, A:dword, B:dword 
			mov	eax, DestVec
			mov	ebx, A
			mov	ecx, B
			fld	dword ptr [ebx + VERTEX.x]
			fsub	dword ptr [ecx + VERTEX.x]
			fstp	dword ptr [eax + VERTEX.x]

			fld	dword ptr [ebx + VERTEX.y]
			fsub	dword ptr [ecx + VERTEX.y]
			fstp	dword ptr [eax + VERTEX.y]

			fld	dword ptr [ebx + VERTEX.z]
			fsub	dword ptr [ecx + VERTEX.z]
			fstp	dword ptr [eax + VERTEX.z]
			
			ret
Vec_Sub			endp

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]